//+------------------------------------------------------------------+
//|                                                  Oscillation.mq4 |
//|                                                            timex |
//|                                                http://quantum.by |
//+------------------------------------------------------------------+
#property copyright "timex"
#property link      "http://quantum.by"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 MediumSlateBlue
#property indicator_color2 Ivory


double ExtMapBuffer1[];
double ExtMapBuffer2[];

double oscillator;
double weighted_oscillator;

double profit;

extern int period=160;
extern double divergence=8;
extern int maxbars=0;


string name="Msignal";

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {

//---- additional buffers are used for counting
   IndicatorBuffers(2);
//---- indicators
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexShift(0,0);
   
   SetIndexStyle(1,DRAW_SECTION);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexShift(0,0);

   oscillator=0;
   weighted_oscillator=0;
         
   start();
   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll();
//----
   return(0);
  }
int start()
  {
  
/*    **************************************************/
   int limit, i, counter;
   oscillator=0;
   weighted_oscillator=0;
   
   int counted_bars=IndicatorCounted();
   //---- check for possible errors
   if(counted_bars<0) return(-1);
   
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   
   limit=Bars-counted_bars;
   
   if(maxbars==0) maxbars=limit;
     
   int pos=maxbars-1;
   int tmp=0;
   
  while(pos>=1) {
      if(Close[pos]>Close[pos+1]) oscillator++;
      else oscillator--;
      //if(Close[pos]>Close[pos+1]) oscillator+=Close[pos];
      //else oscillator-=Close[pos];
      //if(Close[pos]>Close[pos+1]) oscillator+=Close[pos]-Close[pos+1];
      //else oscillator+=Close[pos]-Close[pos+1];


      ExtMapBuffer1[pos]=oscillator;
      
      
      weighted_oscillator=0;
      if(maxbars-1-pos<period) {
         /*
         tmp=maxbars-1;
         while(tmp>=maxbars-1-pos) {
            weighted_oscillator+=ExtMapBuffer1[tmp];
            tmp--;
         }
         if(maxbars-1-pos>0) ExtMapBuffer2[pos]=weighted_oscillator/(maxbars-1-pos);
         */
      } else {
      
         tmp=pos+period;         
         while(tmp>=pos) {
            weighted_oscillator+=ExtMapBuffer1[tmp];
            tmp--;
         }
         ExtMapBuffer2[pos]=weighted_oscillator/period;            
      }
      
      
      if(ExtMapBuffer2[pos+1]>ExtMapBuffer1[pos+1] && ExtMapBuffer2[pos]<ExtMapBuffer1[pos]) {      
            ObjectCreate(name+pos,OBJ_ARROW,0,Time[pos],Close[pos]);
            ObjectSet(name+pos,OBJPROP_ARROWCODE,225);
            ObjectSet(name+pos,OBJPROP_COLOR,Crimson);
            
      }
      
      if(ExtMapBuffer2[pos+1]<ExtMapBuffer1[pos+1] && ExtMapBuffer2[pos]>ExtMapBuffer1[pos]) {
            ObjectCreate(name+pos,OBJ_ARROW,0,Time[pos],Close[pos]);
            ObjectSet(name+pos,OBJPROP_ARROWCODE,226);
            ObjectSet(name+pos,OBJPROP_COLOR,Crimson);
            
      }
      
      if(ExtMapBuffer2[pos]<ExtMapBuffer1[pos] && ExtMapBuffer1[pos]-ExtMapBuffer2[pos]>divergence) {
            ObjectCreate(name+pos,OBJ_ARROW,0,Time[pos],Close[pos]);
            ObjectSet(name+pos,OBJPROP_ARROWCODE,226);
            ObjectSet(name+pos,OBJPROP_COLOR,OrangeRed);
      }
      
      if(ExtMapBuffer2[pos]>ExtMapBuffer1[pos] && ExtMapBuffer2[pos]-ExtMapBuffer1[pos]>divergence) {
            ObjectCreate(name+pos,OBJ_ARROW,0,Time[pos],Close[pos]);
            ObjectSet(name+pos,OBJPROP_ARROWCODE,225);
            ObjectSet(name+pos,OBJPROP_COLOR,OrangeRed);
      }


      
      pos--;   
   }
   
 

 
 
 
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+